"use strict";

require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.object.assign.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.weak-map.js");
require("core-js/modules/esnext.weak-map.delete-all.js");
require("core-js/modules/web.url.to-json.js");
require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.number.constructor.js");
var _react = _interopRequireWildcard(require("react"));
var _react2 = require("@testing-library/react");
var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));
var _Druthers = _interopRequireDefault(require("./Druthers"));
var _mocks = require("../../mocks");
var _defaultProps = _interopRequireDefault(require("../../utils/defaultProps"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
global.console.error = jest.fn();
jest.mock("react", function () {
  return _objectSpread(_objectSpread({}, jest.requireActual("react")), {}, {
    useRef: jest.fn()
  });
});
var massageDataIn = jest.fn().mockImplementation(_defaultProps.default.massageDataIn);
var otherProps;
beforeEach(function () {
  jest.clearAllMocks();
  otherProps = {
    component_Select: function component_Select(props) {
      return /*#__PURE__*/_react.default.createElement("div", {
        type: "Select",
        "data-props": props
      });
    },
    component_CheckRadio: function component_CheckRadio(props) {
      return /*#__PURE__*/_react.default.createElement("div", {
        type: "CheckRadio",
        "data-props": props
      });
    },
    component_CheckBox: _mocks.MockElement,
    component_Radio: _mocks.MockElement,
    component_Switch: _mocks.MockElement,
    options: [{
      value: "1",
      label: "option"
    }],
    creatable: true
  };
  _react.useRef.mockImplementation(function () {
    return {
      current: {
        scrollWidth: 100,
        offsetWidth: 101
      }
    };
  });
});
describe("should render Select", function () {
  beforeEach(function () {
    otherProps.creatable = false;
  });
  it("when creatable", function () {
    var testRenderer = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_Druthers.default, _extends({}, _defaultProps.default, otherProps, {
      creatable: true
    })));
    expect(testRenderer.toJSON()).toMatchSnapshot();
  });
  it("when checkRadioMaxCount is less", function () {
    var testRenderer = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_Druthers.default, _extends({}, _defaultProps.default, otherProps, {
      checkRadioMaxCount: 0
    })));
    expect(testRenderer.toJSON()).toMatchSnapshot();
  });
  it("when hasOptionGroups", function () {
    var optionGroups = [{
      value: "1",
      label: "option",
      options: [{
        value: "2",
        label: "child"
      }]
    }];
    var testRenderer = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_Druthers.default, _extends({}, _defaultProps.default, otherProps, {
      options: optionGroups
    })));
    expect(testRenderer.toJSON()).toMatchSnapshot();
  });
  it("when overflown, with invisible CheckRadio", function (done) {
    _react.useRef.mockImplementation(function () {
      return {
        current: {
          scrollWidth: 101,
          offsetWidth: 100
        }
      };
    });
    var testRenderer = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_Druthers.default, _extends({}, _defaultProps.default, otherProps)));
    setTimeout(function () {
      expect(testRenderer.toJSON()).toMatchSnapshot();
      done();
    });
  });
});
describe("should render CheckRadio", function () {
  it("when not creatable", function () {
    var testRenderer = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_Druthers.default, _extends({}, _defaultProps.default, otherProps, {
      creatable: false
    })));
    expect(testRenderer.toJSON()).toMatchSnapshot();
  });
  it("when not overflown", function (done) {
    var testRenderer = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_Druthers.default, _extends({}, _defaultProps.default, otherProps, {
      creatable: false
    })));
    setTimeout(function () {
      expect(testRenderer.toJSON()).toMatchSnapshot();
      done();
    });
  });
});
it("should call massageDataIn", function () {
  (0, _react2.render)( /*#__PURE__*/_react.default.createElement(_Druthers.default, _extends({}, _defaultProps.default, otherProps, {
    massageDataIn: massageDataIn
  })));
  expect(massageDataIn).toBeCalled();
});
it("should console error with no options and not creatable", function () {
  (0, _react2.render)( /*#__PURE__*/_react.default.createElement(_Druthers.default, _extends({}, _defaultProps.default, otherProps, {
    options: [],
    creatable: false
  })));
  expect(global.console.error).toBeCalledWith("Select has no options and is not creatable, nothing to display. Consider adding options or making it creatable");
});
it("should not console error with no options and creatable", function () {
  (0, _react2.render)( /*#__PURE__*/_react.default.createElement(_Druthers.default, _extends({}, _defaultProps.default, otherProps, {
    options: []
  })));
  expect(global.console.error).not.toBeCalled();
});