"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Selection = exports.Option = void 0;
require("core-js/modules/es.array.concat.js");
var _styled = _interopRequireDefault(require("@emotion/styled"));
var _Item = _interopRequireDefault(require("./Item"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var Selection = (0, _styled.default)(_Item.default)(function (props) {
  return "\n  border-radius: ".concat(props.styles_borderRadius, ";\n  align-items: center;\n  justify-content: space-between;\n  margin-top: calc(").concat(props.styles_selection_margin, " / 2);\n  margin-bottom: calc(").concat(props.styles_selection_margin, " / 2);\n  padding-top: ").concat(props.styles_selection_paddingTop, ";\n  padding-bottom: ").concat(props.styles_selection_paddingBottom, ";\n  padding-left: ").concat(props.styles_selection_paddingLeft, ";\n  padding-right: ").concat(props.removable ? "0" : props.styles_selection_paddingRight, ";\n\n  & .remove:not(svg):not(path) {\n    display: flex;\n    border: none;\n    border-radius: ").concat(props.styles_borderRadius, ";\n    margin-top: -").concat(props.styles_selection_paddingTop, ";\n    margin-bottom: -").concat(props.styles_selection_paddingBottom, ";\n    padding-top: ").concat(props.styles_selection_paddingTop, ";\n    padding-bottom: ").concat(props.styles_selection_paddingBottom, ";\n    padding-left: ").concat(props.styles_selection_paddingLeft, ";\n    padding-right: ").concat(props.styles_selection_paddingRight, ";\n    background-color: transparent;\n    font-size: 1em;\n\n    svg {\n      fill: ").concat(props.styles_colors_primary, ";\n      width: ").concat(props.styles_icon_width, ";\n      height: ").concat(props.styles_icon_width, ";\n    }\n\n    ").concat(props.styles_selectionHighlighted === props.item.value ? "background-color: ".concat(props.styles_colors_warning, ";\n\n      svg {\n        fill: ").concat(props.styles_colors_warningBold, ";\n      }") : "", "\n  }\n\n  ").concat(props.styles_multiple ? "display: inline-flex;\n        background-color: ".concat(props.styles_colors_secondary, ";\n        margin-right: ").concat(props.styles_selection_margin, ";") : "display: flex;", "\n  ").concat(props.styles_rightToLeft ? "\n        transform: scaleX(-1);\n        flex-direction: row-reverse;\n        padding-left: ".concat(props.removable ? "0" : props.styles_selection_paddingRight, ";\n        padding-right: ").concat(props.styles_selection_paddingLeft, ";") : "", "\n");
});
exports.Selection = Selection;
var Option = (0, _styled.default)(_Item.default)(function (props) {
  return "\n  padding-top: ".concat(props.styles_option_paddingTop, ";\n  padding-bottom: ").concat(props.styles_option_paddingBottom, ";\n  padding-right: ").concat(props.styles_option_paddingRight, ";\n  padding-left: ").concat(props.styles_option_paddingLeft, ";\n  &:first-of-type{\n    border-top-left-radius: ").concat(props.styles_borderRadius, ";\n    border-top-right-radius: ").concat(props.styles_borderRadius, ";\n  }\n  &:last-of-type{\n    border-bottom-left-radius: ").concat(props.styles_borderRadius, ";\n    border-bottom-right-radius: ").concat(props.styles_borderRadius, ";\n  }\n  z-index: 999;\n\n  ").concat(props.styles_optionHighlighted != null && props.styles_optionHighlighted === props.item.value ? "background-color: ".concat(props.styles_colors_highlight, ";") : "", "\n  ").concat(props.styles_rightToLeft ? "transform: scaleX(-1);\n        text-align: right;" : "", "\n  ").concat(props.item.childGroup && props.item.value == null ? "color: ".concat(props.styles_colors_secondary, ";\n        font-size: .8em;") : "", "\n  ").concat(props.item.childGroup && props.item.value != null ? "font-weight: bold;" : "", "\n  ").concat(props.item.group ? "margin-left: ".concat(props.item.group.split(".").length * 2, "em;") : "", "\n");
});
exports.Option = Option;