"use strict";

require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.number.constructor.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
require("core-js/modules/es.object.assign.js");
var _react = _interopRequireDefault(require("react"));
var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));
var _mocks = require("../../mocks");
var _styled = require("./styled");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
describe("Selection", function () {
  it("styles", function () {
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Selection, _extends({}, _mocks.mockStyles, {
      item: _mocks.mockItem,
      removable: false,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
  it("removable = true", function () {
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Selection, _extends({}, _mocks.mockStyles, {
      item: _mocks.mockItem,
      removable: true,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
  it("should highlight removable", function () {
    var mockHighlightedItem = _objectSpread(_objectSpread({}, _mocks.mockItem), {}, {
      value: "highlight"
    });
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Selection, _extends({}, _mocks.mockStyles, {
      item: mockHighlightedItem,
      styles_selectionHighlighted: mockHighlightedItem.value,
      removable: true,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
  it("styles_multiple = true", function () {
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Selection, _extends({}, _mocks.mockStyles, {
      item: _mocks.mockItem,
      styles_multiple: true,
      removable: false,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
  it("styles_rightToLeft = true", function () {
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Selection, _extends({}, _mocks.mockStyles, {
      item: _mocks.mockItem,
      styles_rightToLeft: true,
      removable: false,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
  it("styles_rightToLeft = true and removable = true", function () {
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Selection, _extends({}, _mocks.mockStyles, {
      item: _mocks.mockItem,
      styles_rightToLeft: true,
      removable: true,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
});
describe("Option", function () {
  it("styles", function () {
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Option, _extends({}, _mocks.mockStyles, {
      item: _mocks.mockItem,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
  it("should highlight", function () {
    var mockHighlightedItem = _objectSpread(_objectSpread({}, _mocks.mockItem), {}, {
      value: "highlight"
    });
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Option, _extends({}, _mocks.mockStyles, {
      item: mockHighlightedItem,
      styles_optionHighlighted: mockHighlightedItem.value,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
  it("should not highlight if empty value", function () {
    var mockHighlightedItem = _objectSpread(_objectSpread({}, _mocks.mockItem), {}, {
      value: null
    });
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Option, _extends({}, _mocks.mockStyles, {
      item: mockHighlightedItem,
      styles_optionHighlighted: mockHighlightedItem.value,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
  it("styles_rightToLeft = true", function () {
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Option, _extends({}, _mocks.mockStyles, {
      item: _mocks.mockItem,
      styles_rightToLeft: true,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
  it("has item group and childGroup = 0", function () {
    var mockGroupItem = _objectSpread(_objectSpread({}, _mocks.mockItem), {}, {
      childGroup: "0"
    });
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Option, _extends({}, _mocks.mockStyles, {
      item: mockGroupItem,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
  it("has item group and childGroup = 0.0.0", function () {
    var mockGroupItem = _objectSpread(_objectSpread({}, _mocks.mockItem), {}, {
      childGroup: "0.0.0"
    });
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Option, _extends({}, _mocks.mockStyles, {
      item: mockGroupItem,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
  it("has item group and childGroup = 0 and value = null", function () {
    var mockGroupItem = _objectSpread(_objectSpread({}, _mocks.mockItem), {}, {
      childGroup: "0",
      value: null
    });
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Option, _extends({}, _mocks.mockStyles, {
      item: mockGroupItem,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
  it("has item group and no childGroup", function () {
    var mockGroupItem = _objectSpread(_objectSpread({}, _mocks.mockItem), {}, {
      group: "0"
    });
    var wrapper = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_styled.Option, _extends({}, _mocks.mockStyles, {
      item: mockGroupItem,
      svg_Remove: _mocks.MockSvg
    })));
    expect(wrapper).toMatchSnapshot();
  });
});