"use strict";

require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.number.constructor.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
require("core-js/modules/es.array.find.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.object.assign.js");
var _react = _interopRequireDefault(require("react"));
var _enzyme = require("enzyme");
var _enzymeToJson = _interopRequireDefault(require("enzyme-to-json"));
var _mocks = require("../../mocks");
var _Search = _interopRequireDefault(require("./Search"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var placeholder = "Placeholder";
var onChange = jest.fn();
var onFocus = jest.fn();
var onBlur = jest.fn();
var onKeyDown = jest.fn();
beforeEach(function () {
  jest.clearAllMocks();
});
it("renders", function () {
  var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_Search.default, _extends({}, _mocks.mockStyles, {
    placeholder: placeholder,
    onChange: onChange,
    onKeyDown: onKeyDown,
    onFocus: onFocus,
    onBlur: onBlur,
    hide: false,
    className: "test"
  })));
  expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
});
it("renders disabled", function () {
  var styles = _objectSpread(_objectSpread({}, _mocks.mockStyles), {}, {
    styles_disabled: true
  });
  var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_Search.default, _extends({}, styles, {
    placeholder: placeholder,
    onChange: onChange,
    onKeyDown: onKeyDown,
    onFocus: onFocus,
    onBlur: onBlur,
    hide: false,
    className: "test"
  })));
  expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
});
it("renders searchText", function () {
  var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_Search.default, _extends({}, _mocks.mockStyles, {
    placeholder: placeholder,
    onChange: onChange,
    onKeyDown: onKeyDown,
    onFocus: onFocus,
    onBlur: onBlur,
    hide: false,
    className: "test",
    searchText: "search text"
  })));
  expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
});
it("renders hidden", function () {
  var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_Search.default, _extends({}, _mocks.mockStyles, {
    placeholder: placeholder,
    onChange: onChange,
    onKeyDown: onKeyDown,
    onFocus: onFocus,
    onBlur: onBlur,
    hide: true,
    className: "test"
  })));
  expect((0, _enzymeToJson.default)(wrapper)).toMatchSnapshot();
});
it("forwards ref", function () {
  var ref = /*#__PURE__*/_react.default.createRef();
  (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_Search.default, _extends({}, _mocks.mockStyles, {
    placeholder: placeholder,
    onChange: onChange,
    onKeyDown: onKeyDown,
    onFocus: onFocus,
    onBlur: onBlur,
    hide: false,
    ref: ref
  })));
  expect(ref.current).toBeDefined();
});
it("should keyDown", function () {
  var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_Search.default, _extends({}, _mocks.mockStyles, {
    placeholder: placeholder,
    onChange: onChange,
    onKeyDown: onKeyDown,
    onFocus: onFocus,
    onBlur: onBlur,
    hide: false
  })));
  wrapper.find("input").simulate("keyDown");
  expect(onKeyDown).toBeCalled();
});
it("should change", function () {
  var wrapper = (0, _enzyme.shallow)( /*#__PURE__*/_react.default.createElement(_Search.default, _extends({}, _mocks.mockStyles, {
    placeholder: placeholder,
    onChange: onChange,
    onKeyDown: onKeyDown,
    onFocus: onFocus,
    onBlur: onBlur,
    hide: false
  })));
  wrapper.find("input").simulate("change");
  expect(onChange).toBeCalled();
});