"use strict";

require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.number.constructor.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
require("core-js/modules/es.object.assign.js");
var _react = _interopRequireDefault(require("react"));
var _react2 = require("@storybook/react");
var _addonActions = require("@storybook/addon-actions");
var _mocks = require("../../mocks");
var _defaultProps = _interopRequireDefault(require("../../utils/defaultProps"));
var _styled = require("../SelectionWrapper/styled");
var _styled2 = require("../SelectionList/styled");
var _styled3 = require("../Search/styled");
var _styled4 = require("../Selection/styled");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
var selectionList = /*#__PURE__*/_react.default.createElement(_styled2.SelectionList, _extends({
  itemList: _defaultProps.default.selection,
  onClick: (0, _addonActions.action)("onRemove"),
  removable: !_defaultProps.default.disabled && _defaultProps.default.removable,
  Item: _styled4.Selection
}, _mocks.mockStyles));
var search = /*#__PURE__*/_react.default.createElement(_styled3.Search, _extends({
  hide: false,
  placeholder: _defaultProps.default.placeholder,
  searchText: "",
  onKeyDown: (0, _addonActions.action)("onKeyDown"),
  onChange: (0, _addonActions.action)("onChange")
}, _mocks.mockStyles));
(0, _react2.storiesOf)("(Internal) SelectionWrapper", module).add("closed", function () {
  return /*#__PURE__*/_react.default.createElement(_styled.SelectionWrapper, _extends({
    onFocus: (0, _addonActions.action)("onFocus"),
    onBlur: (0, _addonActions.action)("onBlur")
  }, _mocks.mockStyles, {
    areOptionsOpen: false,
    SelectionList: selectionList,
    Search: search
  }));
});
(0, _react2.storiesOf)("(Internal) SelectionWrapper", module).add("open", function () {
  return /*#__PURE__*/_react.default.createElement(_styled.SelectionWrapper, _extends({
    onFocus: (0, _addonActions.action)("onFocus"),
    onBlur: (0, _addonActions.action)("onBlur")
  }, _mocks.mockStyles, {
    areOptionsOpen: true,
    SelectionList: selectionList,
    Search: search
  }));
});
var styles = _objectSpread(_objectSpread({}, _mocks.mockStyles), {}, {
  styles_disabled: true
});
(0, _react2.storiesOf)("(Internal) SelectionWrapper", module).add("disabled", function () {
  return /*#__PURE__*/_react.default.createElement(_styled.SelectionWrapper, _extends({
    onFocus: (0, _addonActions.action)("onFocus"),
    onBlur: (0, _addonActions.action)("onBlur")
  }, styles, {
    areOptionsOpen: false,
    SelectionList: /*#__PURE__*/_react.default.createElement(_styled2.SelectionList, _extends({
      itemList: _defaultProps.default.selection,
      onClick: (0, _addonActions.action)("onRemove"),
      removable: !_defaultProps.default.disabled && _defaultProps.default.removable,
      Item: _styled4.Selection
    }, styles)),
    Search: /*#__PURE__*/_react.default.createElement(_styled3.Search, _extends({
      placeholder: _defaultProps.default.placeholder,
      searchText: "",
      onKeyDown: (0, _addonActions.action)("onKeyDown"),
      onChange: (0, _addonActions.action)("onChange")
    }, styles))
  }));
});