"use strict";

require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.object.assign.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.weak-map.js");
require("core-js/modules/esnext.weak-map.delete-all.js");
require("core-js/modules/web.url.to-json.js");
require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.number.constructor.js");
var _react = _interopRequireWildcard(require("react"));
var _react2 = require("@testing-library/react");
var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));
var _mocks = require("../../mocks");
var _SelectionWrapper = _interopRequireDefault(require("./SelectionWrapper"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
jest.mock("react", function () {
  return _objectSpread(_objectSpread({}, jest.requireActual("react")), {}, {
    useRef: jest.fn()
  });
});
var onFocus = jest.fn();
var onBlur = jest.fn();

// This is done internally in the component... but doesn't work appropriately while testing
_react.useRef.mockImplementation(function () {
  return {
    current: {
      focus: onFocus,
      blur: onBlur
    }
  };
});
beforeEach(function () {
  jest.clearAllMocks();
});
it("renders", function () {
  var testRenderer = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_SelectionWrapper.default, _extends({}, _mocks.mockStyles, {
    className: "test",
    areOptionsOpen: false,
    onFocus: onFocus,
    onBlur: onBlur,
    SelectionList: /*#__PURE__*/_react.default.createElement(_mocks.MockElement, null),
    Search: /*#__PURE__*/_react.default.createElement(_mocks.MockInput, null),
    svg_Expand: _mocks.MockSvg
  })));
  expect(testRenderer.toJSON()).toMatchSnapshot();
});
it("renders disabled", function () {
  var styles = _objectSpread(_objectSpread({}, _mocks.mockStyles), {}, {
    styles_disabled: true
  });
  var testRenderer = _reactTestRenderer.default.create( /*#__PURE__*/_react.default.createElement(_SelectionWrapper.default, _extends({}, styles, {
    className: "test",
    areOptionsOpen: false,
    onFocus: onFocus,
    onBlur: onBlur,
    SelectionList: /*#__PURE__*/_react.default.createElement(_mocks.MockElement, null),
    Search: /*#__PURE__*/_react.default.createElement(_mocks.MockInput, null),
    svg_Expand: _mocks.MockSvg
  })));
  expect(testRenderer.toJSON()).toMatchSnapshot();
});
it("should close", function () {
  var _render = (0, _react2.render)( /*#__PURE__*/_react.default.createElement(_SelectionWrapper.default, _extends({}, _mocks.mockStyles, {
      className: "test",
      areOptionsOpen: true,
      onFocus: onFocus,
      onBlur: onBlur,
      SelectionList: /*#__PURE__*/_react.default.createElement(_mocks.MockElement, null),
      Search: /*#__PURE__*/_react.default.createElement(_mocks.MockInput, null),
      svg_Expand: _mocks.MockSvg
    }))),
    getByRole = _render.getByRole;
  _react2.fireEvent.click(getByRole("textbox"));
  expect(onBlur).toBeCalled();
});
it("should open", function () {
  var _render2 = (0, _react2.render)( /*#__PURE__*/_react.default.createElement(_SelectionWrapper.default, _extends({}, _mocks.mockStyles, {
      className: "test",
      areOptionsOpen: false,
      onFocus: onFocus,
      onBlur: onBlur,
      SelectionList: /*#__PURE__*/_react.default.createElement(_mocks.MockElement, null),
      Search: /*#__PURE__*/_react.default.createElement(_mocks.MockInput, null),
      svg_Expand: _mocks.MockSvg
    }))),
    getByRole = _render2.getByRole;
  _react2.fireEvent.click(getByRole("textbox"));
  expect(onFocus).toBeCalled();
});
it("should do nothing if 'removing'", function () {
  var _render3 = (0, _react2.render)( /*#__PURE__*/_react.default.createElement(_SelectionWrapper.default, _extends({}, _mocks.mockStyles, {
      className: "test",
      areOptionsOpen: false,
      onFocus: onFocus,
      onBlur: onBlur,
      SelectionList: /*#__PURE__*/_react.default.createElement(_mocks.MockElement, null),
      Search: /*#__PURE__*/_react.default.createElement(_mocks.MockInput, null),
      svg_Expand: _mocks.MockSvg
    }))),
    getByRole = _render3.getByRole;
  var target = document.createElement("div");
  target.classList.add("remove");
  _react2.fireEvent.click(getByRole("textbox"), {
    target: target
  });
  expect(onFocus).not.toBeCalled();
  expect(onBlur).not.toBeCalled();
});