"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Switch = exports.Radio = exports.CheckBox = void 0;
require("core-js/modules/es.array.concat.js");
var _styled = _interopRequireDefault(require("@emotion/styled"));
var _SingleCheckRadio = _interopRequireDefault(require("./SingleCheckRadio"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var CheckBox = (0, _styled.default)(_SingleCheckRadio.default)(function (props) {
  return "\n  margin-right: ".concat(props.styles_checkRadio_marginBetween, ";\n  display: inline-flex;\n  align-items: center;\n  user-select: none;\n  cursor: ").concat(props.disabled ? "not-allowed" : "pointer", ";\n  ").concat(props.disabled ? "&& .check-radio-display {\n        border-color: ".concat(props.styles_colors_disabled, ";\n      }") : "&:hover .check-radio-display {\n        border-color: ".concat(props.styles_colors_primary, ";\n      }\n      &.focus .check-radio-display {\n        border-color: ").concat(props.styles_colors_primary, ";\n      }"), "\n\n  .check-radio-display {\n    border-radius: ").concat(props.styles_borderRadius, ";\n    margin-right: ").concat(props.styles_checkRadio_labelMargin, ";\n    padding-top: ").concat(props.styles_checkRadio_paddingTop, ";\n    padding-bottom: ").concat(props.styles_checkRadio_paddingBottom, ";\n    padding-right: ").concat(props.styles_checkRadio_paddingRight, ";\n    padding-left: ").concat(props.styles_checkRadio_paddingLeft, ";\n    border: ").concat(props.styles_checkRadio_borderWidth, " solid\n      ").concat(props.styles_colors_secondary, ";\n    width: ").concat(props.styles_icon_width, ";\n    height: ").concat(props.styles_icon_width, ";\n    background-color: ").concat(props.disabled ? props.styles_colors_disabled : props.styles_colors_background, ";\n\n    svg {\n      fill: ").concat(props.styles_colors_primary, ";\n      width: ").concat(props.styles_icon_width, ";\n      height: ").concat(props.styles_icon_width, ";\n      ").concat(!props.checked ? "visibility: hidden;" : "", "\n    }\n  }\n\n  input {\n    opacity: 0;\n    width: 0;\n  }\n");
});
exports.CheckBox = CheckBox;
var Radio = (0, _styled.default)(_SingleCheckRadio.default)(function (props) {
  return "\n  margin-right: ".concat(props.styles_checkRadio_marginBetween, ";\n  display: inline-flex;\n  align-items: center;\n  cursor: pointer;\n  user-select: none;\n  cursor: ").concat(props.disabled ? "not-allowed" : "pointer", ";\n  ").concat(props.disabled ? "&& .check-radio-display {\n          border-color: ".concat(props.styles_colors_disabled, ";\n        }") : "&:hover .check-radio-display {\n          border-color: ".concat(props.styles_colors_primary, ";\n        }\n        &.focus .check-radio-display {\n          border-color: ").concat(props.styles_colors_primary, ";\n        }"), "\n\n  .check-radio-display {\n    border-radius: 100%;\n    margin-right: ").concat(props.styles_checkRadio_labelMargin, ";\n    padding-top: ").concat(props.styles_checkRadio_paddingTop, ";\n    padding-bottom: ").concat(props.styles_checkRadio_paddingBottom, ";\n    padding-right: ").concat(props.styles_checkRadio_paddingRight, ";\n    padding-left: ").concat(props.styles_checkRadio_paddingLeft, ";\n    background-size: 0.1em;\n    border: ").concat(props.styles_checkRadio_borderWidth, " solid\n      ").concat(props.styles_colors_secondary, ";\n    width: ").concat(props.styles_icon_width, ";\n    height: ").concat(props.styles_icon_width, ";\n    background-color: ").concat(props.disabled ? props.styles_colors_disabled : props.styles_colors_background, ";\n    ").concat(props.checked ? "background-color: ".concat(props.styles_colors_secondary, ";") : "", "\n\n    svg {\n      visibility: hidden;\n      width: ").concat(props.styles_icon_width, ";\n      height: ").concat(props.styles_icon_width, ";\n    }\n  }\n\n  input {\n    opacity: 0;\n    width: 0;\n  }\n");
});
exports.Radio = Radio;
var Switch = (0, _styled.default)(_SingleCheckRadio.default)(function (props) {
  return "\n  display: inline-flex;\n  align-items: center;\n  cursor: pointer;\n  user-select: none;\n  cursor: ".concat(props.disabled ? "not-allowed" : "pointer", ";\n  ").concat(props.disabled ? "&& .check-radio-display {\n        border-color: ".concat(props.styles_colors_disabled, ";\n      }") : "&:hover .check-radio-display {\n        border-color: ".concat(props.styles_colors_primary, ";\n      }\n      &.focus .check-radio-display {\n        border-color: ").concat(props.styles_colors_primary, ";\n      }"), "\n\n  .check-radio-display {\n    margin-right: ").concat(props.styles_checkRadio_labelMargin, ";\n    display: inline-flex;\n    align-items: center;\n    border-radius: 1em;\n    padding-top: ").concat(props.styles_checkRadio_paddingTop, ";\n    padding-bottom: ").concat(props.styles_checkRadio_paddingBottom, ";\n    padding-right: ").concat(props.styles_checkRadio_paddingRight, ";\n    padding-left: ").concat(props.styles_checkRadio_paddingLeft, ";\n    border: ").concat(props.styles_checkRadio_borderWidth, " solid\n      ").concat(props.styles_colors_secondary, ";\n    width: calc(").concat(props.styles_icon_width, " * 2);\n    height: ").concat(props.styles_icon_width, ";\n    background-color: ").concat(props.disabled ? props.styles_colors_disabled : props.styles_colors_background, ";\n\n    svg {\n      width: ").concat(props.styles_icon_width, ";\n      height: ").concat(props.styles_icon_width, ";\n      border-radius: 100%;\n      ").concat(props.checked ? "margin-left: ".concat(props.styles_icon_width, ";\n          background-color: ").concat(props.styles_colors_primary, ";") : "background-color: ".concat(props.styles_colors_secondary, ";"), "\n      fill-opacity: 0;\n    }\n  }\n\n  input {\n    opacity: 0;\n    width: 0;\n  }\n");
});
exports.Switch = Switch;