"use strict";

var _react = require("@testing-library/react");
var _usePlaceAbove = _interopRequireDefault(require("./usePlaceAbove"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var rect;
var optionsWrapperRect;
beforeEach(function () {
  rect = {
    bottom: 80,
    height: 80,
    left: 0,
    right: 200,
    top: 0,
    width: 200,
    x: 0,
    y: 600
  };
  optionsWrapperRect = {
    bottom: 80,
    height: 80,
    left: 0,
    right: 200,
    top: 0,
    width: 200,
    x: 0,
    y: 600
  };
  global.innerHeight = 1000;
  global.scrollY = 200;
});
it("Should default to false", function () {
  var _renderHook = (0, _react.renderHook)(function () {
      return (0, _usePlaceAbove.default)(rect, optionsWrapperRect);
    }),
    result = _renderHook.result;
  expect(result.current).toBe(false);
});
it("Should place above", function () {
  // Window height
  global.innerHeight = 150;
  global.scrollY = 150;

  // Below height
  rect.y = 100;
  rect.height = 100;
  optionsWrapperRect.height = 101;
  var _renderHook2 = (0, _react.renderHook)(function () {
      return (0, _usePlaceAbove.default)(rect, optionsWrapperRect);
    }),
    result = _renderHook2.result;
  expect(result.current).toBe(false);
});
it("Should place below", function () {
  // Window height
  global.innerHeight = 150;
  global.scrollY = 150;

  // Below height
  rect.y = 100;
  rect.height = 100;
  optionsWrapperRect.height = 100;
  var _renderHook3 = (0, _react.renderHook)(function () {
      return (0, _usePlaceAbove.default)(rect, optionsWrapperRect);
    }),
    result = _renderHook3.result;
  expect(result.current).toBe(false);
});
it("Should place below if less space above", function () {
  // Window height
  global.innerHeight = 100;
  global.scrollY = 100;

  // Below height
  rect.y = 50;
  rect.height = 100;
  optionsWrapperRect.height = 100;
  var _renderHook4 = (0, _react.renderHook)(function () {
      return (0, _usePlaceAbove.default)(rect, optionsWrapperRect);
    }),
    result = _renderHook4.result;
  expect(result.current).toBe(false);
});
it("Should place below with no space", function () {
  // Window height
  global.innerHeight = 1;
  global.scrollY = 1;

  // Below height
  rect.y = 0;
  rect.height = 2;
  optionsWrapperRect.height = 20;
  var _renderHook5 = (0, _react.renderHook)(function () {
      return (0, _usePlaceAbove.default)(rect, optionsWrapperRect);
    }),
    result = _renderHook5.result;
  expect(result.current).toBe(false);
});