"use strict";

var _mocks = require("../../mocks");
var _react = require("@testing-library/react");
var _useRefRect = _interopRequireDefault(require("./useRefRect"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var ref;
beforeEach(function () {
  var rect = _mocks.mockRect;
  rect.offsetLeft = ref = {
    current: {
      getClientRects: function getClientRects() {
        return [{
          top: 10,
          bottom: 110,
          left: 20,
          right: 220,
          width: 200,
          height: 100
        }];
      },
      offsetLeft: 15,
      offsetTop: 25
    }
  };
});
it("Should get default", function () {
  ref = {
    current: null
  };
  global.innerWidth = 10;
  global.innerHeight = 10;
  var _renderHook = (0, _react.renderHook)(function () {
      return (0, _useRefRect.default)(ref);
    }),
    result = _renderHook.result;
  expect(result.current).toStrictEqual({
    bottom: 0,
    height: 0,
    left: 0,
    right: 0,
    top: 0,
    width: 0,
    x: -10,
    y: -10
  });
});
it("Should get ref rectangle", function () {
  var _renderHook2 = (0, _react.renderHook)(function () {
      return (0, _useRefRect.default)(ref);
    }),
    result = _renderHook2.result;
  expect(result.current).toStrictEqual({
    top: 10,
    bottom: 110,
    left: 20,
    right: 220,
    width: 200,
    height: 100,
    x: 15,
    y: 25
  });
});