"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/es.weak-map.js");
require("core-js/modules/esnext.weak-map.delete-all.js");
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.symbol.iterator.js");
var _react = require("@testing-library/react");
var _callOnChange = _interopRequireDefault(require("../../utils/callOnChange"));
var _useUpdateSelection = _interopRequireWildcard(require("./useUpdateSelection"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
jest.mock("../../utils/callOnChange");
_callOnChange.default.mockImplementation(jest.fn());
var isCheckRadio;
var props;
beforeEach(function () {
  isCheckRadio = false;
  props = {
    selection: [],
    options: [],
    massageDataOut: function massageDataOut(_, value) {
      return value;
    },
    onChange: jest.fn(),
    allowDuplicates: true,
    multiple: true,
    parseTo: "string"
  };
  jest.clearAllMocks();
});
it("Should default", function () {
  (0, _react.renderHook)(function () {
    return (0, _useUpdateSelection.default)(props, isCheckRadio);
  });
  expect(_callOnChange.default).toBeCalledWith(props, [], "replace");
});
describe("allowDuplicates", function () {
  var withDuplicates = [{
    value: "1",
    label: "dup"
  }, {
    value: "1",
    label: "dup"
  }, {
    value: "1",
    label: "dup"
  }, {
    value: "2",
    label: "other"
  }];
  var options = [{
    value: "1",
    label: "dup"
  }, {
    value: "2",
    label: "other"
  }];
  it("Should allow duplicates", function () {
    props.selection = withDuplicates;
    props.options = options;
    (0, _react.renderHook)(function () {
      return (0, _useUpdateSelection.default)(props, isCheckRadio);
    });
    expect(_callOnChange.default).toBeCalledWith(props, ["1", "1", "1", "2"], "replace");
  });
  it("Should not allow duplicates", function () {
    props.selection = withDuplicates;
    props.options = options;
    props.allowDuplicates = false;
    (0, _react.renderHook)(function () {
      return (0, _useUpdateSelection.default)(props, isCheckRadio);
    });
    expect(_callOnChange.default).toBeCalledWith(props, ["1", "2"], "replace");
  });
});
describe("single selection", function () {
  var selection = [{
    value: "1",
    label: "dup"
  }, {
    value: "2",
    label: "other"
  }];
  var options = [{
    value: "1",
    label: "dup"
  }, {
    value: "2",
    label: "other"
  }];
  it("Should allow multiple", function () {
    props.selection = selection;
    props.options = options;
    (0, _react.renderHook)(function () {
      return (0, _useUpdateSelection.default)(props, isCheckRadio);
    });
    expect(_callOnChange.default).toBeCalledWith(props, ["1", "2"], "replace");
  });
  it("Should not allow multiple", function () {
    props.selection = selection;
    props.options = options;
    props.multiple = false;
    (0, _react.renderHook)(function () {
      return (0, _useUpdateSelection.default)(props, isCheckRadio);
    });
    expect(_callOnChange.default).toBeCalledWith(props, ["1"], "replace");
  });
});
describe("creatable", function () {
  var selection = [{
    value: "1",
    label: "dup"
  }, {
    value: "created",
    label: "created"
  }];
  var options = [{
    value: "1",
    label: "dup"
  }, {
    value: "2",
    label: "other"
  }];
  it("Should not allow created", function () {
    props.selection = selection;
    props.options = options;
    (0, _react.renderHook)(function () {
      return (0, _useUpdateSelection.default)(props, isCheckRadio);
    });
    expect(_callOnChange.default).toBeCalledWith(props, ["1"], "replace");
  });
  it("Should allow created", function () {
    props.selection = selection;
    props.options = options;
    props.creatable = true;
    (0, _react.renderHook)(function () {
      return (0, _useUpdateSelection.default)(props, isCheckRadio);
    });
    expect(_callOnChange.default).toBeCalledWith(props, ["1", "created"], "replace");
  });
});
describe("booleanSwitch", function () {
  var options = [{
    value: "true",
    label: "Yes"
  }, {
    value: "false",
    label: "No"
  }];
  it("Should never be empty and default false", function () {
    isCheckRadio = true;
    props.options = options;
    props.multiple = false;
    (0, _react.renderHook)(function () {
      return (0, _useUpdateSelection.default)(props, isCheckRadio);
    });
    expect(_callOnChange.default).toBeCalledWith(props, ["false"], "replace");
  });
  it("Should never be empty and default true", function () {
    isCheckRadio = true;
    props.options = [{
      value: "false",
      label: "No"
    }];
    props.multiple = false;
    (0, _react.renderHook)(function () {
      return (0, _useUpdateSelection.default)(props, isCheckRadio);
    });
    expect(_callOnChange.default).toBeCalledWith(props, ["true"], "replace");
  });
});
describe("parseTo", function () {
  it("should be string", function () {
    (0, _react.renderHook)(function () {
      return (0, _useUpdateSelection.default)(props, isCheckRadio);
    });
    expect(_callOnChange.default).toBeCalled();
  });
});
describe("allBooleanValues", function () {
  var options = [{
    value: "true",
    label: "Yes"
  }, {
    value: "false",
    label: "No"
  }];
  it("should be true", function () {
    expect((0, _useUpdateSelection.allBooleanValues)(options)).toBe(true);
  });
  it("should be false", function () {
    options.push({
      value: "not bool",
      label: "not bool"
    });
    expect((0, _useUpdateSelection.allBooleanValues)(options)).toBe(false);
  });
});
describe("isBooleanSwitch", function () {
  var options = [{
    value: "true",
    label: "Yes"
  }, {
    value: "false",
    label: "No"
  }];
  it("should be true, two options", function () {
    props.options = options;
    props.multiple = false;
    expect((0, _useUpdateSelection.isBooleanSwitch)(props)).toBe(true);
  });
  it("should be true, one option", function () {
    props.options = [{
      value: "true",
      label: "Yes"
    }];
    props.multiple = false;
    expect((0, _useUpdateSelection.isBooleanSwitch)(props)).toBe(true);
  });
  it("should be false, multiple", function () {
    props.options = options;
    props.multiple = true;
    expect((0, _useUpdateSelection.isBooleanSwitch)(props)).toBe(false);
  });
  it("should be false, too many options", function () {
    props.options = [{
      value: "true",
      label: "Yes"
    }, {
      value: "false",
      label: "No"
    }, {
      value: "false",
      label: "Not"
    }];
    props.multiple = false;
    expect((0, _useUpdateSelection.isBooleanSwitch)(props)).toBe(false);
  });
  it("should be false, no options", function () {
    props.options = [];
    props.multiple = false;
    expect((0, _useUpdateSelection.isBooleanSwitch)(props)).toBe(false);
  });
  it("should be false, not bool", function () {
    props.options = [{
      value: "not bool",
      label: "not bool"
    }];
    props.multiple = false;
    expect((0, _useUpdateSelection.isBooleanSwitch)(props)).toBe(false);
  });
});