"use strict";

require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mockStyles = exports.mockRect = exports.mockItemList = exports.mockItem = exports.mockEvent = exports.MockSvg = exports.MockInput = exports.MockElement = void 0;
require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.number.constructor.js");
var _react = _interopRequireDefault(require("react"));
var _defaultProps = _interopRequireDefault(require("./utils/defaultProps"));
var _utils = require("./utils/utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var noop = function noop() {};
var mockStyles = _objectSpread({
  styles_width: 600,
  styles_multiple: false,
  styles_disabled: false,
  styles_hasSelection: false,
  styles_hasOptions: true,
  styles_optionHighlighted: [],
  styles_rightToLeft: false
}, (0, _utils.withKeys)(_defaultProps.default, "styles_"));
exports.mockStyles = mockStyles;
var mockItem = {
  value: "42",
  label: "Meaning of life"
};
exports.mockItem = mockItem;
var mockItemList = [{
  value: "1",
  label: "Item 1"
}, {
  value: "2",
  label: "Item 2"
}, {
  value: "3",
  label: "Item 3"
}, {
  value: "4",
  label: "Item 4"
}, {
  value: "5",
  label: "Item 5"
}];
exports.mockItemList = mockItemList;
var mockEvent = {
  preventDefault: noop
};
exports.mockEvent = mockEvent;
var MockElement = function MockElement(props) {
  return /*#__PURE__*/_react.default.createElement("div", {
    "data-props": props
  });
};
exports.MockElement = MockElement;
var MockInput = function MockInput(props) {
  return /*#__PURE__*/_react.default.createElement("input", {
    type: "text",
    "data-props": props
  });
};
exports.MockInput = MockInput;
var MockSvg = function MockSvg() {
  return /*#__PURE__*/_react.default.createElement("svg", null, /*#__PURE__*/_react.default.createElement("path", {
    d: "M0 0L5 5Z"
  }));
};
exports.MockSvg = MockSvg;
var mockRect = {
  top: 10,
  bottom: 110,
  left: 20,
  right: 220,
  width: 200,
  height: 100,
  x: 15,
  y: 25
};
exports.mockRect = mockRect;