"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
require("core-js/modules/es.array.map.js");
require("core-js/modules/es.array.find.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.string.starts-with.js");
require("core-js/modules/es.array.splice.js");
require("core-js/modules/es.array.index-of.js");
var _utils = require("./utils");
var internalCallOnChange = function internalCallOnChange(props, value) {
  props.onChange({
    target: {
      value: props.massageDataOut(props, value),
      name: props.name
    }
  });
};
var callOnChange = function callOnChange(props, newValue) {
  var method = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "add";
  // methods: 'add', 'remove', 'replace'
  if (method === "replace") return internalCallOnChange(props, (0, _utils.castArray)(newValue));
  var value = method === "add" ? (0, _utils.castArray)(newValue) : [];
  if (props.multiple) {
    value = props.selection.map(function (option) {
      return option.value;
    });
    if (method === "add") {
      var newOption = props.options.find(function (option) {
        return option.value === newValue;
      });
      if (newOption != null && newOption.childGroup) {
        // Option has child options, remove selected children
        value = props.selection.filter(function (option) {
          return !option.group || !option.group.startsWith(newOption.childGroup);
        }).map(function (option) {
          return option.value;
        });
      }
      value.push(String(newValue)); // Add
    } else {
      value.splice(value.indexOf(String(newValue)), 1); // Remove
    }
  }

  internalCallOnChange(props, value);
};
var _default = callOnChange;
exports.default = _default;