"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
require("core-js/modules/es.string.starts-with.js");
require("core-js/modules/es.string.ends-with.js");
require("core-js/modules/es.array.includes.js");
require("core-js/modules/es.string.includes.js");
require("core-js/modules/es.array.map.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.to-string.js");
var _utils = require("./utils");
var _massageOptions = require("./massageOptions");
var _fuzzyset = _interopRequireDefault(require("fuzzyset.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var fuzzySearch = function fuzzySearch(item, searchTerm) {
  var fuzzy = (0, _fuzzyset.default)();
  fuzzy.add(item.label.toLowerCase());
  var result = fuzzy.get(searchTerm);
  return result ? result.length : false;
};
var sortComparator = function sortComparator(a, b) {
  return b.rank - a.rank || a.item.label.localeCompare(b.item.label);
}; // sort by rank, then alphabetically

var onParentRankZeroRemoveValue = function onParentRankZeroRemoveValue(item) {
  delete item.value; // Don't allow rank 0 parent to be selectable during searching

  return item;
};
var filterOptions = function filterOptions(props, searchTerm) {
  var calculateRank = function calculateRank(option) {
    if (option.label.toLowerCase() === searchTerm) return 32;else if (option.value != null && option.value.toLowerCase() === searchTerm) return 16;else if (option.label.toLowerCase().startsWith(searchTerm)) return 8;else if (option.label.toLowerCase().endsWith(searchTerm)) return 4;else if (option.label.toLowerCase().includes(searchTerm)) return 2;else if (fuzzySearch(option, searchTerm)) return 1;else return 0;
  };
  var options = props.options;
  if (!(0, _utils.isEmpty)(searchTerm)) {
    searchTerm = searchTerm.toLowerCase();
    options = (0, _massageOptions.flattenOptions)((0, _utils.rankFilterSort)(props.hierarchicalOptions, calculateRank, sortComparator, "options", onParentRankZeroRemoveValue), props.hasOptionGroups);
  }
  options = (0, _utils.without)(options, props.selection);
  if (props.hasOptionGroups) {
    // Remove child groups if parent is selected
    var groupsToRemove = props.selection.filter(function (selection) {
      return selection.childGroup;
    }).map(function (selection) {
      return selection.childGroup;
    });
    options = options.filter(function (option) {
      return !option.group || !groupsToRemove.some(function (group) {
        return option.group.startsWith(group);
      });
    });
  }
  return options;
};
var _default = filterOptions;
exports.default = _default;