"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.array.map.js");
require("core-js/modules/es.array.slice.js");
require("core-js/modules/es.parse-int.js");
require("core-js/modules/es.number.constructor.js");
require("core-js/modules/es.parse-float.js");
require("core-js/modules/es.array.includes.js");
var emptyValue = function emptyValue(props) {
  switch (props.parseTo.toLowerCase()) {
    case "number":
    case "int":
    case "float":
    case "boolean":
      return undefined;
    case "string":
    default:
      return "";
  }
};
var massageDataOut = function massageDataOut(props, onChangeValue) {
  if (!onChangeValue.length) return !props.alwaysReturnArray && !props.multiple ? emptyValue(props) : onChangeValue;
  switch (props.parseTo.toLowerCase()) {
    case "number":
    case "int":
      onChangeValue = onChangeValue.slice().map(function (val) {
        return parseInt(val, 10);
      }).filter(function (val) {
        return !Number.isNaN(val);
      });
      break;
    case "float":
      onChangeValue = onChangeValue.slice().map(function (val) {
        return parseFloat(val);
      }).filter(function (val) {
        return !Number.isNaN(val);
      });
      break;
    case "boolean":
      onChangeValue = onChangeValue.slice().filter(function (val) {
        return ["true", "false"].includes(val.toLowerCase());
      }).map(function (val) {
        return val.toLowerCase() === "true";
      });
      break;
    case "string":
    default:
      break;
  }
  return !props.alwaysReturnArray && !props.multiple ? onChangeValue[0] : onChangeValue;
};
var _default = massageDataOut;
exports.default = _default;