"use strict";

require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.array.from.js");
require("core-js/modules/es.array.slice.js");
require("core-js/modules/es.regexp.exec.js");
require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.flattenOptions = exports.default = void 0;
require("core-js/modules/es.array.concat.js");
require("core-js/modules/es.array.map.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.array.includes.js");
require("core-js/modules/es.string.includes.js");
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
var getKey = function getKey(keyGetter, option) {
  return typeof keyGetter === "string" ? option[keyGetter] : keyGetter(option);
};
var flattenOptions = function flattenOptions(options, hasOptionGroups) {
  var _ref;
  if (!hasOptionGroups) return options;
  return (_ref = []).concat.apply(_ref, _toConsumableArray(options.map(function (option) {
    if (option.options == null) return option;
    return [option].concat(_toConsumableArray(flattenOptions(option.options, hasOptionGroups))); // Recursion
  })));
};
exports.flattenOptions = flattenOptions;
var massageOptions = function massageOptions(props) {
  var hasOptionGroups = false;
  var strigifyOption = function strigifyOption(option) {
    var newOption = {};
    var value = getKey(props.valueKey, option);
    var label = getKey(props.labelKey, option);
    if (label != null) newOption["label"] = String(label);
    if (value != null) newOption["value"] = String(value);
    return newOption;
  };
  var internalMassageOptions = function internalMassageOptions(options, groups) {
    var currentGroup = 0;
    return options.map(function (option) {
      var newOption = strigifyOption(option);
      if (groups.length) newOption["group"] = groups.join(".");
      if (getKey(props.optionsKey, option) == null) {
        // No child options
        return newOption;
      } else {
        // has child options
        hasOptionGroups = true;
        var childGroup = [].concat(_toConsumableArray(groups), [currentGroup]); // the group for this option's children
        currentGroup = currentGroup + 1;
        newOption["childGroup"] = childGroup.join(".");
        newOption["options"] = internalMassageOptions(getKey(props.optionsKey, option), childGroup); // Recursion

        return newOption;
      }
    });
  };
  var removeDuplicates = function removeDuplicates(options) {
    var previousValues = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    options = options.filter(function (option) {
      if (option.value == null) return true;
      var includes = previousValues.includes(option.value);
      if (includes) {
        if (option.childGroup == null) {
          return false;
        } else {
          delete option.value;
        }
      } else {
        previousValues.push(option.value);
      }
      return true;
    });
    return options.filter(function (option) {
      if (option.options == null) return true;
      option.options = removeDuplicates(option.options, previousValues); // Recursion

      // Clean up parent
      if (!option.options.length) {
        if (option.value == null) {
          return false;
        }
        delete option.options;
        delete option.childGroup;
      }
      return true;
    });
  };
  var hierarchicalOptions = internalMassageOptions(props.options, []);
  if (!props.allowDuplicates) {
    // Make all options Distinct
    hierarchicalOptions = removeDuplicates(hierarchicalOptions);
    hasOptionGroups = hierarchicalOptions.some(function (option) {
      return option.options != null;
    });
  }
  var options = flattenOptions(hierarchicalOptions, hasOptionGroups);
  return {
    hasOptions: !!options.length,
    hasOptionGroups: hasOptionGroups,
    options: options,
    hierarchicalOptions: hierarchicalOptions
  };
};
var _default = massageOptions;
exports.default = _default;