"use strict";

require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.weak-map.js");
require("core-js/modules/esnext.weak-map.delete-all.js");
require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.number.constructor.js");
var _massageOptions = _interopRequireWildcard(require("./massageOptions"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var props;
var expectedProps;
var funcValueKey = function funcValueKey(obj) {
  return obj["value"];
};
var funcLabelKey = function funcLabelKey(obj) {
  return obj["label"];
};
var funcOptionKey = function funcOptionKey(obj) {
  return obj["options"];
};
beforeEach(function () {
  props = {
    options: [],
    allowDuplicates: true,
    valueKey: funcValueKey,
    labelKey: funcLabelKey,
    optionsKey: funcOptionKey
  };
  expectedProps = {
    hasOptions: false,
    hasOptionGroups: false,
    options: [],
    hierarchicalOptions: []
  };
});
describe("options", function () {
  it("should always be objects of strings", function () {
    props.options = [{
      label: 1,
      value: 1
    }];
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      options: [{
        label: "1",
        value: "1"
      }],
      hierarchicalOptions: [{
        label: "1",
        value: "1"
      }]
    }));
  });
  it("should not allow duplicates", function () {
    props.allowDuplicates = false;
    props.options = [{
      label: 1,
      value: 1
    }, {
      label: 1,
      value: "1"
    }, {
      label: "One",
      value: 1
    }];
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      options: [{
        label: "1",
        value: "1"
      }],
      hierarchicalOptions: [{
        label: "1",
        value: "1"
      }]
    }));
  });
  it("should not get option label/value with bad key selector func", function () {
    var funcNothing = function funcNothing(object) {
      return object["nothing"];
    };
    props.options = [{
      label: "One",
      value: "1"
    }];
    props.valueKey = funcNothing;
    props.labelKey = funcNothing;
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      options: [{}],
      hierarchicalOptions: [{}]
    }));
  });
  it("should get option label/value with key selector func", function () {
    var funcValueKey = function funcValueKey(object) {
      return object["otherValue"];
    };
    var funcLabelKey = function funcLabelKey(object) {
      return object["otherLabel"];
    };
    props.options = [{
      otherLabel: "One",
      otherValue: "1",
      label: "nothing",
      value: "nothing"
    }];
    props.valueKey = funcValueKey;
    props.labelKey = funcLabelKey;
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      options: [{
        label: "One",
        value: "1"
      }],
      hierarchicalOptions: [{
        label: "One",
        value: "1"
      }]
    }));
  });
  it("should not get option label/value with bad key selector string", function () {
    props.options = [{
      label: "One",
      value: "1"
    }];
    props.valueKey = "nothing";
    props.labelKey = "nothing";
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      options: [{}],
      hierarchicalOptions: [{}]
    }));
  });
  it("should get option label/value with key selector string", function () {
    props.options = [{
      otherLabel: "One",
      otherValue: "1",
      label: "nothing",
      value: "nothing"
    }];
    props.valueKey = "otherValue";
    props.labelKey = "otherLabel";
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      options: [{
        label: "One",
        value: "1"
      }],
      hierarchicalOptions: [{
        label: "One",
        value: "1"
      }]
    }));
  });
});
describe("option groups", function () {
  var optionGroups = [{
    label: "Parent 1",
    value: "1",
    options: [{
      label: "P1 Child 1",
      value: "p1child1"
    }]
  }, {
    label: "Parent 2 without child options",
    value: 2
  }, {
    label: "Parent 3 without value",
    options: [{
      label: "P3 Child 1",
      value: "p3child1"
    }]
  }];
  var otherOptionGroups = [{
    otherLabel: "Parent 1",
    otherValue: "1",
    otherOptions: [{
      otherLabel: "P1 Child 1",
      otherValue: "p1child1"
    }]
  }, {
    otherLabel: "Parent 2 without child options",
    otherValue: 2
  }, {
    otherLabel: "Parent 3 without value",
    otherOptions: [{
      otherLabel: "P3 Child 1",
      otherValue: "p3child1"
    }]
  }];
  it("should flatten option groups", function () {
    props.options = optionGroups;
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      hasOptionGroups: true,
      options: [{
        childGroup: "0",
        label: "Parent 1",
        value: "1",
        options: expect.anything()
      }, {
        group: "0",
        label: "P1 Child 1",
        value: "p1child1"
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }, {
        childGroup: "1",
        label: "Parent 3 without value",
        options: expect.anything()
      }, {
        group: "1",
        label: "P3 Child 1",
        value: "p3child1"
      }],
      hierarchicalOptions: [{
        childGroup: "0",
        label: "Parent 1",
        value: "1",
        options: [{
          group: "0",
          label: "P1 Child 1",
          value: "p1child1"
        }]
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }, {
        childGroup: "1",
        label: "Parent 3 without value",
        options: [{
          group: "1",
          label: "P3 Child 1",
          value: "p3child1"
        }]
      }]
    }));
  });
  it("should keep flattened option groups next to each other", function () {
    props.options = optionGroups;
    var outputProps = (0, _massageOptions.default)(props);
    expect(outputProps.options[0].group).toBeUndefined();
    expect(outputProps.options[0].childGroup).toBe("0");
    expect(outputProps.options[1].group).toBe("0");
    expect(outputProps.options[1].childGroup).toBeUndefined();
    expect(outputProps.options[2].group).toBeUndefined();
    expect(outputProps.options[2].childGroup).toBeUndefined();
    expect(outputProps.options[3].group).toBeUndefined();
    expect(outputProps.options[3].childGroup).toBe("1");
    expect(outputProps.options[4].group).toBe("1");
    expect(outputProps.options[4].childGroup).toBeUndefined();
  });
  it("should allow infinite option nesting", function () {
    var infiniteOptionGroupOptions = [{
      value: "burger",
      label: "Burger",
      options: [{
        value: "patty",
        label: "Patty",
        options: [{
          value: "beef",
          label: "Beef"
        }, {
          value: "veggie",
          label: "Veggie",
          options: [{
            value: "blackbean",
            label: "Black bean"
          }, {
            value: "grain",
            label: "Grain"
          }, {
            value: "mirepoix",
            label: "Mirepoix"
          }]
        }, {
          value: "lamb",
          label: "Lamb"
        }]
      }, {
        value: "cheese",
        label: "Cheese"
      }, {
        value: "pickle",
        label: "Pickle"
      }, {
        value: "lettuce",
        label: "Lettuce"
      }, {
        value: "tomato",
        label: "Tomato"
      }, {
        value: "all_condiments",
        label: "Condiments",
        options: [{
          value: "ketchup",
          label: "Ketchup"
        }, {
          value: "mustard",
          label: "Mustard"
        }, {
          value: "mayo",
          label: "Mayo"
        }]
      }]
    }, {
      value: "to_go",
      label: "To Go"
    }];
    props.options = infiniteOptionGroupOptions;
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptionGroups: true,
      hasOptions: true,
      options: [{
        label: "Burger",
        childGroup: "0",
        value: "burger",
        options: expect.anything()
      }, {
        group: "0",
        childGroup: "0.0",
        label: "Patty",
        value: "patty",
        options: expect.anything()
      }, {
        group: "0.0",
        label: "Beef",
        value: "beef"
      }, {
        group: "0.0",
        childGroup: "0.0.0",
        label: "Veggie",
        value: "veggie",
        options: expect.anything()
      }, {
        group: "0.0.0",
        label: "Black bean",
        value: "blackbean"
      }, {
        group: "0.0.0",
        label: "Grain",
        value: "grain"
      }, {
        group: "0.0.0",
        label: "Mirepoix",
        value: "mirepoix"
      }, {
        group: "0.0",
        label: "Lamb",
        value: "lamb"
      }, {
        group: "0",
        label: "Cheese",
        value: "cheese"
      }, {
        group: "0",
        label: "Pickle",
        value: "pickle"
      }, {
        group: "0",
        label: "Lettuce",
        value: "lettuce"
      }, {
        group: "0",
        label: "Tomato",
        value: "tomato"
      }, {
        group: "0",
        childGroup: "0.1",
        label: "Condiments",
        value: "all_condiments",
        options: expect.anything()
      }, {
        group: "0.1",
        label: "Ketchup",
        value: "ketchup"
      }, {
        group: "0.1",
        label: "Mustard",
        value: "mustard"
      }, {
        group: "0.1",
        label: "Mayo",
        value: "mayo"
      }, {
        label: "To Go",
        value: "to_go"
      }],
      hierarchicalOptions: [{
        childGroup: "0",
        value: "burger",
        label: "Burger",
        options: [{
          group: "0",
          childGroup: "0.0",
          value: "patty",
          label: "Patty",
          options: [{
            group: "0.0",
            value: "beef",
            label: "Beef"
          }, {
            group: "0.0",
            childGroup: "0.0.0",
            value: "veggie",
            label: "Veggie",
            options: [{
              group: "0.0.0",
              value: "blackbean",
              label: "Black bean"
            }, {
              group: "0.0.0",
              value: "grain",
              label: "Grain"
            }, {
              group: "0.0.0",
              value: "mirepoix",
              label: "Mirepoix"
            }]
          }, {
            group: "0.0",
            value: "lamb",
            label: "Lamb"
          }]
        }, {
          group: "0",
          value: "cheese",
          label: "Cheese"
        }, {
          group: "0",
          value: "pickle",
          label: "Pickle"
        }, {
          group: "0",
          value: "lettuce",
          label: "Lettuce"
        }, {
          group: "0",
          value: "tomato",
          label: "Tomato"
        }, {
          group: "0",
          childGroup: "0.1",
          value: "all_condiments",
          label: "Condiments",
          options: [{
            group: "0.1",
            value: "ketchup",
            label: "Ketchup"
          }, {
            group: "0.1",
            value: "mustard",
            label: "Mustard"
          }, {
            group: "0.1",
            value: "mayo",
            label: "Mayo"
          }]
        }]
      }, {
        value: "to_go",
        label: "To Go"
      }]
    }));
  });
  it("should not allow duplicates", function () {
    props.allowDuplicates = false;
    props.options = [{
      label: "Parent 1",
      value: "1",
      options: [{
        label: "P1 Child 1",
        value: "p1child1"
      }, {
        label: "DUPLICATE P1 Child 1",
        value: "p1child1"
      }]
    }, {
      label: "Parent 2 without child options",
      value: 2
    }, {
      label: "Parent 3 without value",
      options: [{
        label: "P3 Child 1",
        value: "p3child1"
      }, {
        label: "DUPLICATE P1 Child 1",
        value: "p1child1"
      }]
    }, {
      label: "DUPLICATE Parent 1",
      value: 1
    }, {
      label: "DUPLICATE Parent 2",
      value: 2
    }];
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      hasOptionGroups: true,
      options: [{
        childGroup: "0",
        label: "Parent 1",
        value: "1",
        options: expect.anything()
      }, {
        group: "0",
        label: "P1 Child 1",
        value: "p1child1"
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }, {
        childGroup: "1",
        label: "Parent 3 without value",
        options: expect.anything()
      }, {
        group: "1",
        label: "P3 Child 1",
        value: "p3child1"
      }],
      hierarchicalOptions: [{
        childGroup: "0",
        label: "Parent 1",
        value: "1",
        options: [{
          group: "0",
          label: "P1 Child 1",
          value: "p1child1"
        }]
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }, {
        childGroup: "1",
        label: "Parent 3 without value",
        options: [{
          group: "1",
          label: "P3 Child 1",
          value: "p3child1"
        }]
      }]
    }));
  });
  it("should remove duplicates and cleanup parents", function () {
    props.allowDuplicates = false;
    props.options = [{
      label: "Parent 1 CLEAN",
      value: "1",
      options: [{
        label: "DUPLICATE of parent",
        value: "1"
      }]
    }, {
      label: "Parent 2 without child options",
      value: 2
    }, {
      label: "Parent 3 without value REMOVE",
      options: [{
        label: "DUPLICATE",
        value: "2"
      }]
    }];
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      hasOptionGroups: false,
      options: [{
        label: "Parent 1 CLEAN",
        value: "1"
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }],
      hierarchicalOptions: [{
        label: "Parent 1 CLEAN",
        value: "1"
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }]
    }));
  });
  it("should not get options with bad key selector functions", function () {
    var funcNothing = function funcNothing(object) {
      return object["nothing"];
    };
    props.allowDuplicates = false;
    props.options = optionGroups;
    props.optionsKey = funcNothing;
    props.valueKey = funcNothing;
    props.labelKey = funcNothing;
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      options: [{}, {}, {}],
      hierarchicalOptions: [{}, {}, {}]
    }));
  });
  it("should not get child options with bad key selector func", function () {
    var funcNothing = function funcNothing(object) {
      return object["nothing"];
    };
    props.options = optionGroups;
    props.optionsKey = funcNothing;
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      options: [{
        label: "Parent 1",
        value: "1"
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }, {
        label: "Parent 3 without value"
      }],
      hierarchicalOptions: [{
        label: "Parent 1",
        value: "1"
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }, {
        label: "Parent 3 without value"
      }]
    }));
  });
  it("should not get options with bad key selector strings", function () {
    props.options = optionGroups;
    props.allowDuplicates = false;
    props.optionsKey = "nothing";
    props.valueKey = "nothing";
    props.labelKey = "nothing";
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      options: [{}, {}, {}],
      hierarchicalOptions: [{}, {}, {}]
    }));
  });
  it("should not get child options with bad key selector string", function () {
    props.options = optionGroups;
    props.optionsKey = "nothing";
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      options: [{
        label: "Parent 1",
        value: "1"
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }, {
        label: "Parent 3 without value"
      }],
      hierarchicalOptions: [{
        label: "Parent 1",
        value: "1"
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }, {
        label: "Parent 3 without value"
      }]
    }));
  });
  it("should get options with key selector functions", function () {
    var funcOptionsKey = function funcOptionsKey(object) {
      return object["otherOptions"];
    };
    var funcValueKey = function funcValueKey(object) {
      return object["otherValue"];
    };
    var funcLabelKey = function funcLabelKey(object) {
      return object["otherLabel"];
    };
    props.options = otherOptionGroups;
    props.optionsKey = funcOptionsKey;
    props.valueKey = funcValueKey;
    props.labelKey = funcLabelKey;
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      hasOptionGroups: true,
      options: [{
        childGroup: "0",
        label: "Parent 1",
        value: "1",
        options: expect.anything()
      }, {
        group: "0",
        label: "P1 Child 1",
        value: "p1child1"
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }, {
        childGroup: "1",
        label: "Parent 3 without value",
        options: expect.anything()
      }, {
        group: "1",
        label: "P3 Child 1",
        value: "p3child1"
      }],
      hierarchicalOptions: [{
        childGroup: "0",
        label: "Parent 1",
        value: "1",
        options: [{
          group: "0",
          label: "P1 Child 1",
          value: "p1child1"
        }]
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }, {
        childGroup: "1",
        label: "Parent 3 without value",
        options: [{
          group: "1",
          label: "P3 Child 1",
          value: "p3child1"
        }]
      }]
    }));
  });
  it("should get child options with key selector strings", function () {
    props.options = otherOptionGroups;
    props.optionsKey = "otherOptions";
    props.valueKey = "otherValue";
    props.labelKey = "otherLabel";
    expect((0, _massageOptions.default)(props)).toStrictEqual(_objectSpread(_objectSpread({}, expectedProps), {}, {
      hasOptions: true,
      hasOptionGroups: true,
      options: [{
        childGroup: "0",
        label: "Parent 1",
        value: "1",
        options: expect.anything()
      }, {
        group: "0",
        label: "P1 Child 1",
        value: "p1child1"
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }, {
        childGroup: "1",
        label: "Parent 3 without value",
        options: expect.anything()
      }, {
        group: "1",
        label: "P3 Child 1",
        value: "p3child1"
      }],
      hierarchicalOptions: [{
        childGroup: "0",
        label: "Parent 1",
        value: "1",
        options: [{
          group: "0",
          label: "P1 Child 1",
          value: "p1child1"
        }]
      }, {
        label: "Parent 2 without child options",
        value: "2"
      }, {
        childGroup: "1",
        label: "Parent 3 without value",
        options: [{
          group: "1",
          label: "P3 Child 1",
          value: "p3child1"
        }]
      }]
    }));
  });
});
describe("flattenOptions", function () {
  it("should flatten", function () {
    var options = [{
      label: "something",
      options: [{
        label: "other",
        options: [{
          label: "last"
        }]
      }]
    }];
    var flattened = (0, _massageOptions.flattenOptions)(options, true);
    expect((0, _massageOptions.flattenOptions)(options, false)).toStrictEqual(options);
    expect(flattened).toStrictEqual([{
      label: "something",
      options: expect.anything()
    }, {
      label: "other",
      options: expect.anything()
    }, {
      label: "last"
    }]);

    // Should have same pointer
    expect(flattened[0]).toBe(options[0]);
    expect(flattened[1]).toBe(options[0].options[0]);
    expect(flattened[2]).toBe(options[0].options[0].options[0]);
  });
});