"use strict";

require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.array.index-of.js");
require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.number.constructor.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.define-properties.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.castArray = castArray;
exports.inRange = inRange;
exports.isEmpty = isEmpty;
exports.last = last;
exports.rankFilterSort = void 0;
exports.withKeys = withKeys;
exports.without = without;
exports.withoutKeys = void 0;
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.array.includes.js");
require("core-js/modules/es.string.includes.js");
require("core-js/modules/es.array.map.js");
require("core-js/modules/es.array.sort.js");
require("core-js/modules/es.array.reduce.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.string.starts-with.js");
var _excluded = ["childSum"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function castArray(value) {
  return Array.isArray(value) ? value : [value];
}
function without(array, values) {
  var filtered = array.filter(function (value) {
    return !castArray(values).includes(value);
  });
  return filtered.length === array.length ? array : filtered;
}
function isEmpty(value) {
  if (value == null) {
    return true;
  }
  if (Array.isArray(value) || typeof value == "string") {
    return !value.length;
  }
  if (value && value.size != null) {
    return !value.size;
  }
  if (_typeof(value) === "object") {
    for (var key in value) {
      if (hasOwnProperty.call(value, key)) {
        return false;
      }
    }
    return true;
  }
  return false;
}
function last(array) {
  var length = array == null ? 0 : array.length;
  return length ? array[length - 1] : undefined;
}
function inRange(number, start, end) {
  if (end === undefined) {
    end = start;
    start = 0;
  }
  return number >= Math.min(start, end) && number < Math.max(start, end);
}
var rankFilterSort = function rankFilterSort(items, calculateRank) {
  var comparator = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function (a, b) {
    return b.rank - a.rank;
  };
  var childrenKey = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "children";
  var onParentRankZero = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : function (item) {
    return item;
  };
  var internalRankFilterSort = function internalRankFilterSort(items) {
    var _ref;
    var accRank = 0;
    var filteredItems = items.map(function (item) {
      var newItem = item;
      var rank = calculateRank(newItem);
      if (item[childrenKey]) {
        var _internalRankFilterSo = internalRankFilterSort(item[childrenKey]),
          childSum = _internalRankFilterSo.childSum,
          other = _objectWithoutProperties(_internalRankFilterSo, _excluded);
        newItem = _objectSpread(_objectSpread({}, newItem), {}, _defineProperty({}, childrenKey, other[childrenKey]));
        if (newItem[childrenKey].length === 0) {
          delete newItem[childrenKey];
        }
        if (rank <= 0) {
          newItem = onParentRankZero(newItem);
        }
        rank += childSum;
      }
      accRank += rank;
      return {
        rank: rank,
        item: newItem
      };
    }).filter(function (ranker) {
      return ranker.rank > 0;
    }) // Remove ranks with 0
    .sort(comparator).map(function (ranker) {
      return ranker.item;
    }); // return to just array of items

    return _ref = {}, _defineProperty(_ref, childrenKey, filteredItems), _defineProperty(_ref, "childSum", accRank), _ref;
  };
  return internalRankFilterSort(items)[childrenKey];
};
exports.rankFilterSort = rankFilterSort;
function withKeys(obj, startsWith) {
  var not = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return Object.keys(obj).reduce(function (acc, key) {
    var condition = castArray(startsWith).some(function (word) {
      return key.startsWith(word);
    });
    condition = not ? !condition : condition;
    if (condition) acc[key] = obj[key];
    return acc;
  }, {});
}
var withoutKeys = function withoutKeys(obj, startsWith) {
  return withKeys(obj, startsWith, true);
};
exports.withoutKeys = withoutKeys;